// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruExteriorLights.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_EXTERIOR_LIGHTS__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_EXTERIOR_LIGHTS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'vehicular'
#include "etsi_its_vam_ts_msgs/msg/detail/exterior_lights__struct.hpp"
// Member 'vru_specific'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_specific_exterior_lights__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruExteriorLights __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruExteriorLights __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VruExteriorLights_
{
  using Type = VruExteriorLights_<ContainerAllocator>;

  explicit VruExteriorLights_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : vehicular(_init),
    vru_specific(_init)
  {
    (void)_init;
  }

  explicit VruExteriorLights_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : vehicular(_alloc, _init),
    vru_specific(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _vehicular_type =
    etsi_its_vam_ts_msgs::msg::ExteriorLights_<ContainerAllocator>;
  _vehicular_type vehicular;
  using _vru_specific_type =
    etsi_its_vam_ts_msgs::msg::VruSpecificExteriorLights_<ContainerAllocator>;
  _vru_specific_type vru_specific;

  // setters for named parameter idiom
  Type & set__vehicular(
    const etsi_its_vam_ts_msgs::msg::ExteriorLights_<ContainerAllocator> & _arg)
  {
    this->vehicular = _arg;
    return *this;
  }
  Type & set__vru_specific(
    const etsi_its_vam_ts_msgs::msg::VruSpecificExteriorLights_<ContainerAllocator> & _arg)
  {
    this->vru_specific = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruExteriorLights
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruExteriorLights
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruExteriorLights_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VruExteriorLights_ & other) const
  {
    if (this->vehicular != other.vehicular) {
      return false;
    }
    if (this->vru_specific != other.vru_specific) {
      return false;
    }
    return true;
  }
  bool operator!=(const VruExteriorLights_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VruExteriorLights_

// alias to use template instance with default allocator
using VruExteriorLights =
  etsi_its_vam_ts_msgs::msg::VruExteriorLights_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_EXTERIOR_LIGHTS__STRUCT_HPP_
