// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VruClusterInformationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION_CONTAINER__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'vru_cluster_information'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_information__struct.h"

/// Struct defined in msg/VruClusterInformationContainer in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
  ///   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   vam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  ///  /**
  ///  * @details VruClusterInformationContainer
  ///  * The VRU Cluster Information container of the VAM provides the information/parameters relevant to the VRU cluster.
  ///  * It is mandatory if the VAM is transmitted by VRU cluster leader.
  ///  * It includes the following components (setting indications are specified in clause 7.3.5 of TS 103 300-3):
  ///  *
  ///  * @field vruClusterInformation: set of parammeters releated to the VRU cluster.
  ///  *        When transmitted by a VRU ITS-S, the clusterId and clusterBoundingBoxShape fields inside this DF shall be present.
  ///  *        The clusterBoundingBoxShape is positioned with respect to the position sent in the BasicContainer.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: V2.2.1
  ///  */
  ///     VruClusterInformationContainer::= SEQUENCE{
  ///         vruClusterInformation    VruClusterInformation (WITH COMPONENTS{..., clusterId, clusterBoundingBoxShape PRESENT}),
  ///         ...
  ///     }
  /// ------------------------------------------------------------------------------
  etsi_its_vam_ts_msgs__msg__VruClusterInformation vru_cluster_information;
} etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer.
typedef struct etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer__Sequence
{
  etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_CLUSTER_INFORMATION_CONTAINER__STRUCT_H_
